## org.apache.xpath.functions
Class Function3Args

    java.lang.Object
      org.apache.xpath.Expression
          org.apache.xpath.functions.Function
              org.apache.xpath.functions.FunctionOneArg
                  org.apache.xpath.functions.Function2Args
                      org.apache.xpath.functions.Function3Args

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, ExpressionNode, ExpressionOwner, XPathVisitable

Direct Known Subclasses:
  FuncFormatNumb, FuncSubstring, FunctionMultiArgs, FuncTranslate

    public class Function3Args

extends Function2Args

Base class for functions that accept three arguments.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

Constructor Summary
`Function3Args()`

Method Summary
`void` `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
`boolean` `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
`void` `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`Expression` `getArg2()` Return the third argument passed to the function (at index 2).
`void` `setArg(Expression arg, int argNum)` Set an argument expression for a function.

Methods inherited from class org.apache.xpath.functions.Function2Args
`getArg1`

Methods inherited from class org.apache.xpath.functions.FunctionOneArg
`getArg0, getExpression, setExpression`

Methods inherited from class org.apache.xpath.functions.Function
`callVisitors, execute, postCompileStep`

Methods inherited from class org.apache.xpath.Expression
`asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Function3Args

    public Function3Args()

Method Detail

### getArg2

    public Expression getArg2()

  Return the third argument passed to the function (at index 2).

  Returns:
    An expression that represents the third argument passed to the function.

### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                               int globalsSize)

  This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

  Overrides:
    `fixupVariables` in class `Function2Args`
  Parameters:
    `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

### setArg

    public void setArg(Expression arg,
                       int argNum)
                throws WrongNumberArgsException

  Set an argument expression for a function. This method is called by the XPath compiler.

  Overrides:
    `setArg` in class `Function2Args`
  Parameters:
    `arg` - non-null expression that represents the argument.
    `argNum` - The argument number index.
  Throws:
    `WrongNumberArgsException` - If the argNum parameter is greater than 2.

### checkNumberArgs

    public void checkNumberArgs(int argNum)
                         throws WrongNumberArgsException

  Check that the number of arguments passed to this function is correct.

  Overrides:
    `checkNumberArgs` in class `Function2Args`
  Parameters:
    `argNum` - The number of arguments that is being passed to the function.
  Throws:
    `WrongNumberArgsException`

### canTraverseOutsideSubtree

    public boolean canTraverseOutsideSubtree()

  Tell if this expression or it's subexpressions can traverse outside the current subtree.

  Overrides:
    `canTraverseOutsideSubtree` in class `Function2Args`
  Returns:
    true if traversal outside the context node's subtree can occur.

### callArgVisitors

    public void callArgVisitors(XPathVisitor visitor)

  Description copied from class: `Function`
  Call the visitors for the function arguments.

  Overrides:
    `callArgVisitors` in class `Function2Args`
  See Also:
    `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

### deepEquals

    public boolean deepEquals(Expression expr)

  Description copied from class: `Expression`
  Compare this object with another object and see if they are equal, include the sub heararchy.

  Overrides:
    `deepEquals` in class `Function2Args`
  Parameters:
    `expr` - Another expression object.
  Returns:
    true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
  See Also:
    `Expression.deepEquals(Expression)`

Copyright © 2005 Apache XML Project. All Rights Reserved.